org.jfree.data

## Interface KeyedValues2D

- All Superinterfaces:
    Values2D
  All Known Implementing Classes:
    DefaultKeyedValues2D

      public interface KeyedValues2D
      extends Values2D

  An extension of the `Values2D` interface where a unique key is associated with the row and column indices.

- - ### Method Summary

    All Methods Instance Methods Abstract Methods
    Modifier and Type | Method and Description
    --- | ---
    `int` | `getColumnIndex(java.lang.Comparable key)` Returns the column index for a given key.
    `java.lang.Comparable` | `getColumnKey(int column)` Returns the column key for a given index.
    `java.util.List` | `getColumnKeys()` Returns the column keys.
    `int` | `getRowIndex(java.lang.Comparable key)` Returns the row index for a given key.
    `java.lang.Comparable` | `getRowKey(int row)` Returns the row key for a given index.
    `java.util.List` | `getRowKeys()` Returns the row keys.
    `java.lang.Number` | `getValue(java.lang.Comparable rowKey, java.lang.Comparable columnKey)` Returns the value associated with the specified keys.

    - ### Methods inherited from interface org.jfree.data.Values2D

      `getColumnCount, getRowCount, getValue`

- - ### Method Detail

    - #### getRowKey

          java.lang.Comparable getRowKey(int row)

      Returns the row key for a given index.
      Parameters:
        `row` - the row index (zero-based).
      Returns:
        The row key.
      Throws:
        `java.lang.IndexOutOfBoundsException` - if `row` is out of bounds.

    - #### getRowIndex

          int getRowIndex(java.lang.Comparable key)

      Returns the row index for a given key.
      Parameters:
        `key` - the row key.
      Returns:
        The row index, or `-1` if the key is unrecognised.

    - #### getRowKeys

          java.util.List getRowKeys()

      Returns the row keys.
      Returns:
        The keys.

    - #### getColumnKey

          java.lang.Comparable getColumnKey(int column)

      Returns the column key for a given index.
      Parameters:
        `column` - the column index (zero-based).
      Returns:
        The column key.
      Throws:
        `java.lang.IndexOutOfBoundsException` - if `row` is out of bounds.

    - #### getColumnIndex

          int getColumnIndex(java.lang.Comparable key)

      Returns the column index for a given key.
      Parameters:
        `key` - the column key.
      Returns:
        The column index, or `-1` if the key is unrecognised.

    - #### getColumnKeys

          java.util.List getColumnKeys()

      Returns the column keys.
      Returns:
        The keys.

    - #### getValue

          java.lang.Number getValue(java.lang.Comparable rowKey,
                                    java.lang.Comparable columnKey)

      Returns the value associated with the specified keys.
      Parameters:
        `rowKey` - the row key (`null` not permitted).
        `columnKey` - the column key (`null` not permitted).
      Returns:
        The value.
      Throws:
        `UnknownKeyException` - if either key is not recognised.